program PhotRenamer;

{$R 'version.res' 'version.rc'}

uses
    Windows,
    SysUtils,
    Classes,
    Messages,
  Forms,
  Main in 'Main.pas' {MainForm},
  Info in 'Info.pas' {InfoForm},
  FindFile in 'FindFile.pas';

{$R *.res}

//-----------------------------------------------------------------------------
//  ɋNꂽCX^X邩[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
function IsPrevAppExist(Name:string):Boolean;
begin
    CreateMutex(nil, true, PChar(Name));
    Result := (GetLastError = ERROR_ALREADY_EXISTS);
end;

//-----------------------------------------------------------------------------
//  Nς݂̃CX^XɋNn[2008/01/16]
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N007.html
procedure CopyDataToOld(hWindow: HWND);
var
    i: integer;
    StrBuf: TStringList;
    CopyData: TCopyDataStruct;
    SendData: string;
begin
    //  N
    if (ParamCount > 0) then
    begin
        //  M镶쐬
        try
            StrBuf := TStringList.Create;
            try
                for i := 1 to ParamCount do
                begin
                    StrBuf.Add(ParamStr(i));
                end;
                SendData := StrBuf.CommaText;
            finally
                StrBuf.Free;
            end;
        except
            //  s̎ԂڂɑΉ
            SendData := ParamStr(1);
        end;
        //  \̂𖄂߂
        FillChar(CopyData, SizeOf(CopyData), 0);
        CopyData.dwData := UNIQUE_NUM;
        CopyData.cbData := Length(SendData) + 1;
        CopyData.lpData := StrAlloc(CopyData.cbData);
        //  M
        try
            StrCopy(CopyData.lpData, PChar(SendData));
            hWindow := FindWindow(PChar(UNIQUE_NAM), nil);
            if (hWindow <> 0) then
                SendMessage(hWindow, WM_COPYDATA, WPARAM(Application.Handle), LPARAM(@CopyData));
        finally
            StrDispose(CopyData.lpData);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Nς݂̃CX^XOʂɎẴׂR[obN֐[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
function EnumWndProc(hWindow: HWND; lData: LPARAM): BOOL; stdcall;
begin
    Result := true;
    if GetProp(hWindow, PChar(lData)) = UNIQUE_NUM then
    begin
        if IsIconic(hWindow) then ShowWindow(hWindow, SW_RESTORE);
        SetForegroundWindow(hWindow);
        CopyDataToOld(hWindow);
        Result := false;
    end;
end;

//-----------------------------------------------------------------------------
//  Nς݂̃CX^XOʂɎĂ[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
procedure ActivatePrevApp(Name: string);
begin
    EnumWindows(@EnumWndProc, LPARAM(PChar(Name)));
end;

//-----------------------------------------------------------------------------
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
begin
    if IsPrevAppExist(UNIQUE_NAM) then
    begin
        ActivatePrevApp(UNIQUE_NAM);
    end
    else
    begin
        SetProp(Application.Handle, PChar(UNIQUE_NAM), UNIQUE_NUM);
  Application.Initialize;
  Application.CreateForm(TMainForm, MainForm);
  Application.Run;
        RemoveProp(Application.Handle,PChar(UNIQUE_NAM));
    end;
end.


